#region Using statements
using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Collections.ObjectModel;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint.WebPartPages;
using System.ComponentModel;

using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.WebControls;

// for FilterProviderInfoBar
// after Beta 1 this will be in Microsoft.SharePoint.WebControls (WSS) as well
using Microsoft.SharePoint.Portal.WebControls;
#endregion

namespace FilterWPDemo
{
    public class HelloWorld : Microsoft.SharePoint.WebPartPages.WebPart, ITransformableFilterValues
    {
        FilterProviderInfoBar infoBar;
        LiteralControl userMessage;

        #region ITransformableFilterValues

        [WebPartStorage(Storage.None)]
        public virtual bool AllowMultipleValues
        {
            get { return false; }
        }

        [WebPartStorage(Storage.None)]
        public virtual bool AllowAllValue
        {
            get { return false; }
        }

        [WebPartStorage(Storage.None)]
        public virtual bool AllowEmptyValue
        {
            get { return false; }
        }

        [WebPartStorage(Storage.None)]
        public virtual string ParameterName
        {
            get { return "Demo String"; }
        }

        [WebPartStorage(Storage.None)]
        public virtual ReadOnlyCollection<string> ParameterValues
        {
            get
            {
                string[] values = { "Hello from Office \"12\" servers!" };
                return new ReadOnlyCollection<string>(values);
            }
        }   

        #endregion
        
        [ConnectionProvider("Demo String")]
        public ITransformableFilterValues GetTransformableFilterValuesProvider()
        {
            return this;
        }

        protected override void CreateChildControls()
        {
            infoBar = new FilterProviderInfoBar();
            userMessage = new LiteralControl();
            Controls.Add(this.infoBar);
            Controls.Add(userMessage);
            base.CreateChildControls();
        }

        protected override void OnPreRender(EventArgs e)
        {
            if (WebPartManager.DisplayMode == WebPartManager.BrowseDisplayMode)
            {
                this.Hidden = true;
            }
        }

        protected override void RenderWebPart(HtmlTextWriter output)
        {
            if (WebPartManager.DisplayMode != WebPartManager.BrowseDisplayMode)
            {
                userMessage.Text = "This filter sends a greeting to connected web parts. It is only visible in design mode.";
                base.RenderWebPart(output);
            }
        }

    }
}