using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Collections.ObjectModel;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint.WebPartPages;
using System.ComponentModel;
using System.Text;

using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.WebControls;

namespace FilterWPDemo
{
    public class MSNVirtualEarth : Microsoft.SharePoint.WebPartPages.WebPart
    {
        IFilterValues valuesProvider;
        private FilterConsumerInfoBar infoBar;
        private LiteralControl map;

        [ConnectionConsumer("Coordinates")]
        public void SetConnectionInterface(IFilterValues provider)
        {
            valuesProvider = provider;
            List<ConsumerParameter> l = new List<ConsumerParameter>();
            l.Add(new ConsumerParameter("Coordinates",ConsumerParameterCapabilities.SupportsSingleValue));
            provider.SetConsumerParameters(new ReadOnlyCollection<ConsumerParameter>(l));
        }

        protected override void OnPreRender(EventArgs e)
        {
            if (valuesProvider != null)
            {
                ReadOnlyCollection<String> values = valuesProvider.ParameterValues;
                if (values != null)
                {
                    string coordinates = values[0];

                    ClientScriptManager csm = Page.ClientScript;
                    csm.RegisterClientScriptInclude("ve", "http://virtualearth.msn.com/js/MapControl.js");

                    string mapHtml = "<TABLE><TR><TD><DIV id=\"map1container\"></DIV></TD>";
                    mapHtml += "<TD>&nbsp;&nbsp;</TD>";
                    mapHtml += "<TD><DIV id=\"map2container\"></DIV></TD></TR></TABLE>";
                    map.Text = mapHtml;
                    
                    StringBuilder sb = new StringBuilder();
                    sb.AppendFormat("var map = new VE_MapControl({0}, 'a', \"relative\", 1, 1, 500, 500);", coordinates);
                    sb.AppendLine("document.getElementById(\"map1container\").appendChild(map.element);");
                    sb.AppendFormat("var map2 = new VE_MapControl({0}, 'r', \"relative\", 1, 1, 500, 500);", coordinates);
                    sb.AppendLine("document.getElementById(\"map2container\").appendChild(map2.element);");
                    csm.RegisterStartupScript(typeof(string), "map2", sb.ToString(), true);
                }
                else
                {
                    map.Text = "No coordinates provided.";
                }
            }
            else
            {
                map.Text = "Use web part connections to supply the coordinates to display.";
            }
            base.OnPreRender(e);
        }

        protected override void CreateChildControls()
        {
            infoBar = new FilterConsumerInfoBar();
            Controls.Add(infoBar);

            map = new LiteralControl();
            Controls.Add(map);
            base.CreateChildControls();
        }
     }
}